<template>
  <v-select
    v-model="source"
    :prepend-inner-icon="sourceIcon(source)"
    :items="items"
    :item-text="sourceText"
    return-object
    solo hide-details
    dense flat
    height="32px"
    class="rounded-bl-xl"
    dark :background-color="$store.state.primaryColor"
    :menu-props="{ rounded: '0' }"
  >
    <template #prepend-item>
      <v-list-item>
        <v-list-item-content>
          <v-list-item-title>
            {{ $t('canvas-switcher.select.tooltip.chose') }}
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-divider class="mt-2" />
    </template>
    <template #item="{item, attrs, on}">
      <v-list-item :two-line="!!item.info" v-bind="attrs" v-on="on">
        <v-list-item-icon>
          <v-icon v-text="sourceIcon(item)" />
        </v-list-item-icon>
        <v-list-item-content>
          <v-list-item-title v-text="sourceText(item)" />
          <v-list-item-subtitle>
            <div v-if="item.info">
              {{ item.info }}
            </div>
            <div v-if="item.contributors">
              <span v-if="item.contributors">
                {{ getContributorsString(item.contributors) }}
              </span>
              <span v-if="item.year">
                ({{ item.year }})
              </span>
            </div>
            <div v-if="item.source || item.license" class="sub-sub-title">
              <span v-if="item.license">{{ item.license }} </span>
              <a
                v-if="item.source" :href="item.source"
                rel="noopener noreferrer"
                target="_blank"
              >{{ item.source }}</a>
            </div>
            <div v-if="Object.keys(item.refs).length > 0" class="text-right">
              <ref-links dark :refs="item.refs" />
            </div>
          </v-list-item-subtitle>
        </v-list-item-content>
      </v-list-item>
    </template>
  </v-select>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, VModel,
} from 'vue-property-decorator';
import type { Source } from '@/data';
import { SourceType } from '@/data';
import RefLinks from '../navigation/RefLinks.vue';

/**
 * The select menu in the canvas switcher, allowing a change of source
 */
@Component({
  components: {
    RefLinks,
  },
})
export default class CanvasSwitcherSelect extends Vue {
  @Prop({ required: true })
  items!: Source[];

  @VModel()
  source!: Source;

  sourceText(s: Source): string {
    // Get the translation for the source type
    const key = `canvas-switcher.select.string.${s.type}`;

    // If the translation exists, use it, or use the raw type
    const sourceType = this.$t(key) ? this.$t(key) : this.capitalize(s.type);

    // If a name is present, prepend it to the type
    if (s.name) return `${sourceType} (${this.capitalize(s.name)})`;

    return `${sourceType}`;
  }

  sourceIcon(s: Source): string {
    if (s.type === SourceType.Score) return 'mdi-playlist-music';
    if (s.type === SourceType.Image3D) return 'mdi-playlist-music-outline';
    if (s.type === SourceType.AudioImage) return 'mdi-waveform';
    return 'mdi-file-document-outline';
  }

  capitalize(s: string): string {
    return s.charAt(0).toUpperCase() + s.slice(1);
  }

  getContributorsString(contributors: Record<string, string>): string {
    return Object.values(contributors).join(', ');
  }
}
</script>

<style lang="scss" scoped>
.sub-sub-title > * {
  color: rgba(0,0,0,.4);
  font-size: 11px;
}
</style>
